/* Copyright (c) 1980 Regents of the University of California. All rights
 * reserved.  The Berkeley software License Agreement specifies the terms and
 * conditions for redistribution. 
 *
 * @(#)indent_codes.h      5.2 (Berkeley) 8/28/85 */

/*-
  
                          Copyright (C) 1976
                                by the
                          Board of Trustees
                                of the
                        University of Illinois
  
                         All rights reserved
  
FILE NAME:
        indent_codes.h
  
PURPOSE:
        This include file contains defines for codes used within indent.  They
        are here so that codes passed between and within routines can be
        referenced symbolically.
  
GLOBALS:
        No global variables, just a bunch of defines
  
FUNCTIONS:
        None
*/

enum codes {
    code_eof = 0,		/* end of file */
    newline,
    lparen,			/* '(' or '['.  Also '{' in an
				 * initialization.  */
    rparen,			/* ')' or ']'.  Also '}' in an
				 * initialization.  */
    unary_op, binary_op, postop,
    question, casestmt, colon, semicolon, lbrace, rbrace,
    ident,			/* string or char literal, identifier, number */
    comma, comment, swstmt,
    preesc,			/* '#'.  */
    form_feed, decl,
    sp_paren,			/* if, for, or while token */
    sp_nparen, ifstmt, whilestmt,
    forstmt, stmt, stmtl, elselit, dolit, dohead, ifhead,
    elsehead, period
};

enum rwcodes {
    rw_none = 0,
    rw_break,
    rw_switch,
    rw_case,
    rw_struct_like,		/* struct, enum, union */
    rw_decl,
    rw_sp_paren,		/* if, while, for */
    rw_sp_nparen,		/* do, else */
    rw_sizeof
};
